#! /bin/bash


data_dir="./output_data"

#cd "$data_dir"

master_file="master_file.txt"

let "k=0" "total_tests=0" "total_thick=0"

declare -a n a prop tests thick final_n final_a final_prop final_thick final_tests

echo "DATA BEFORE AVERGAING:">"$master_file"
echo "n, a, Tests, Number thick, proportion thick.  Some rounding damage due to previous script...">>"$master_file"
echo >>"$master_file"

for current_file in $data_dir/*.txt
do

	tmp_str=$(echo "${current_file%.s*t}")
	tmp_str=$(echo "${tmp_str#.*.t}")
		
	exec 3<"$current_file"

	while read -r n[k] a[k] prop[k] <&3; do

		let "tests[k]=$tmp_str"
		let "total_tests=total_tests+$tmp_str"

		thick[k]=$(echo "scale=3; ${tests[k]}*${prop[k]}" | bc -l)
		total_thick=$(echo "scale=3; ${thick[k]}+$total_thick" | bc -l)

		echo "${n[k]}" "${a[k]}" "${tests[k]}" "${thick[k]}" "${prop[k]}" >> "$master_file"

		let "k++"

	done

	exec 3<&-

done

echo >> "$master_file"
echo "There were $total_tests tests." >> "$master_file"
echo "There were approximately $total_thick thick graphs." >> "$master_file"

let "total=k"

echo "There are $total data points, some of which have the same n,a values." >> "$master_file"

echo >> "$master_file"

############################################################

echo "AVERAGED DATA: ">>"$master_file"
echo "point number, n, a, Tests, Number thick, Proportion thick.  Same rounding issue that can't be helped." >> "$master_file"
echo >> "$master_file"

let "k=0" "unique_data_points=0"

while [ "$k" -lt "$total" ]; do

	let "already=-1" "final_prop[k]=0" "i=0"

	while [ "$i" -lt "$k" ]; do

		intak=$(echo "scale=0; ((${a[k]}-${a[i]})*1000)/1" | bc -l)
			
		if [ ${n[i]} -eq ${n[k]} ] && [ $intak -eq 0 ]; then
			let "already=i"
			let "i=k+1000"
		fi 

		let "i++"

	done

	if [ $already -eq -1 ]; then

		let "unique_data_points++"

		final_a[k]=${a[k]}

		let "final_n[k]=${n[k]}"

		final_thick[k]=${thick[k]}
		final_tests[k]=${tests[k]}

	else

		final_a[already]=${a[already]} 

		let "final_n[already]=${n[already]}"

		final_thick[already]=$(echo "scale=3; ${final_thick[already]}+${thick[k]}" | bc -l)
		final_tests[already]=$(echo "scale=3; ${final_tests[already]}+${tests[k]}" | bc -l)

		final_a[k]=0
		final_n[k]=0
		final_tests[k]=1
		final_thick[k]=0

	fi

	let "k++"

done

let "points=${#final_n[@]}" "k=0"

while [ "$k" -lt "$points" ]; do

	if [ "${final_n[k]}" -ne 0 ]; then
	 
 		final_prop[k]=$(echo "scale=3; ${final_thick[k]}/${final_tests[k]}" | bc -l)
		echo "$k" "${final_n[k]}" "${final_a[k]}" "${final_tests[k]}" "${final_thick[k]}" "${final_prop[k]}" >> "$master_file"
	
	fi

	let "k++"

done

echo >> "$master_file"
echo "There are $unique_data_points averaged data points." >> "$master_file"
